/*!
 * The MIT License (MIT)
 * 
 * Copyright (c) 2015 Dossier Stack
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("jquery"));
	else if(typeof define === 'function' && define.amd)
		define("html_highlighter", ["jquery"], factory);
	else if(typeof exports === 'object')
		exports["html_highlighter"] = factory(require("jquery"));
	else
		root["html_highlighter"] = factory(root["jquery"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_1__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.XPathFinder = exports.TextFinder = exports.RangeHighlighter = exports.Ui = exports.HtmlHighlighter = undefined;
	
	var _htmlhighlighter = __webpack_require__(6);
	
	var _htmlhighlighter2 = _interopRequireDefault(_htmlhighlighter);
	
	var _ui = __webpack_require__(10);
	
	var _ui2 = _interopRequireDefault(_ui);
	
	var _rangehighlighter = __webpack_require__(7);
	
	var _rangehighlighter2 = _interopRequireDefault(_rangehighlighter);
	
	var _textfinder = __webpack_require__(8);
	
	var _textfinder2 = _interopRequireDefault(_textfinder);
	
	var _xpathfinder = __webpack_require__(11);
	
	var _xpathfinder2 = _interopRequireDefault(_xpathfinder);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	exports.HtmlHighlighter = _htmlhighlighter2.default;
	exports.Ui = _ui2.default;
	exports.RangeHighlighter = _rangehighlighter2.default;
	exports.TextFinder = _textfinder2.default;
	exports.XPathFinder = _xpathfinder2.default; /* For whatever reason, it is not possible to use the handy
	                                              * `export * from "module"` syntax. */

/***/ },
/* 1 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_1__;

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };
	
	exports.absm_noti = absm_noti;
	exports.is_$ = is_$;
	exports.is_fn = is_fn;
	exports.is_arr = is_arr;
	exports.is_obj = is_obj;
	exports.is_str = is_str;
	exports.like_obj = like_obj;
	exports.is_obj_empty = is_obj_empty;
	exports.inview = inview;
	exports.scrollIntoView = scrollIntoView;
	exports.constructFinder = constructFinder;
	
	var _jquery = __webpack_require__(1);
	
	var _jquery2 = _interopRequireDefault(_jquery);
	
	var _textfinder = __webpack_require__(8);
	
	var _textfinder2 = _interopRequireDefault(_textfinder);
	
	var _xpathfinder = __webpack_require__(11);
	
	var _xpathfinder2 = _interopRequireDefault(_xpathfinder);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function absm_noti() {
	  throw new Error("Abstract method not implemented");
	}
	
	function is_$(el) {
	  return el instanceof _jquery2.default;
	}
	function is_fn(r) {
	  return typeof r === 'function';
	}
	function is_arr(r) {
	  return r instanceof Array;
	}
	function is_obj(r) {
	  return r !== null && (typeof r === "undefined" ? "undefined" : _typeof(r)) === "object";
	}
	function is_str(r) {
	  return typeof r === "string" || r instanceof String;
	}
	
	function like_obj(r) {
	  return r instanceof Object;
	}
	
	function is_obj_empty(x) {
	  if (!like_obj(x)) {
	    throw new Error("Reference not provided or not an object");
	  }
	
	  return Object.keys(x).length === 0;
	}
	
	function inview(el) {
	  var $window = (0, _jquery2.default)(window);
	  var docTop = $window.scrollTop();
	  var docBottom = docTop + $window.height();
	  var top = el.offset().top;
	  var bottom = top + el.height();
	
	  return bottom <= docBottom && top >= docTop;
	}
	
	function scrollIntoView(el, c) {
	  var container = c === undefined ? (0, _jquery2.default)(window) : c;
	  var containerTop = container.scrollTop();
	  var containerBottom = containerTop + container.height();
	  var elemTop = el.offset().top;
	  var elemBottom = elemTop + el.height();
	
	  if (elemTop < containerTop) {
	    container.off().scrollTop(elemTop);
	  } else if (elemBottom > containerBottom) {
	    container.off().scrollTop(elemBottom - container.height());
	  }
	}
	
	/**
	 * <p>Construct appropriate <code>Finder</code>-derived class for a given
	 * subject.</p>
	 * @static
	 *
	 * @param {TextContent} content - reference to <code>TextContent</code>
	 * holding a text representation of the document.
	 * @param {*} subject - subject to find; can be of any type.
	 * */
	function constructFinder(content, subject) {
	  return is_str(subject) || subject instanceof RegExp ? new _textfinder2.default(content, subject) : new _xpathfinder2.default(content, subject);
	}

/***/ },
/* 3 */
/***/ function(module, exports) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	var defaults = exports.defaults = {
	  // Sometimes it is useful for the client to determine how to bring an
	  // element into view via scrolling. If `scrollTo` is set, then it is
	  // called as a function with a jQuery node to scroll to.
	  scrollTo: undefined,
	  maxHighlight: 1,
	  delays: {
	    toggleEntities: 250
	  },
	  useQueryAsClass: false,
	  normalise: true
	};
	
	var Css = exports.Css = {
	  highlight: "hh-highlight",
	  enabled: "hh-enabled",
	  disabled: "hh-disabled"
	};

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	var _jquery = __webpack_require__(1);
	
	var _jquery2 = _interopRequireDefault(_jquery);
	
	var _textnodevisitor = __webpack_require__(15);
	
	var _textnodevisitor2 = _interopRequireDefault(_textnodevisitor);
	
	var _textnodexpath = __webpack_require__(9);
	
	var _textnodexpath2 = _interopRequireDefault(_textnodexpath);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	/**
	 * <p>Holds a representation of a range between two text nodes.</p>
	 * @class
	 * @param {TextContent} content - text representation instance.
	 * @param {Object} start - descriptor of start of range.
	 * @param {Object} end - descriptor of end of range.
	 * */
	var Range = function () {
	  _createClass(Range, null, [{
	    key: "descriptorAbs",
	
	    /**
	     * <p>Create a range descriptor from a global offset.</p>
	     *
	     * @param {Object} marker - Text offset marker object.
	     * @param {number} offset - Global offset.
	     *
	     * @returns {Object} Range descriptor. */
	    value: function descriptorAbs(marker, offset) {
	      return {
	        marker: marker,
	        offset: offset - marker.offset
	      };
	    }
	
	    /**
	     * <p>Create a range descriptor from an offset relative to the start of the
	     * text node.</p>
	     *
	     * @param {Object} marker - Text offset marker object.
	     * @param {number} offset - Relative offset from start of text node.
	     *
	     * @returns {Object} Range descriptor. */
	
	  }, {
	    key: "descriptorRel",
	    value: function descriptorRel(marker, offset) {
	      return {
	        marker: marker,
	        offset: offset
	      };
	    }
	  }]);
	
	  function Range(content, start, end) {
	    _classCallCheck(this, Range);
	
	    this.content = content;
	
	    /* Sanity check: */
	    if (start.marker.offset + start.offset > end.marker.offset + end.offset) {
	      throw new Error("Invalid range: start > end");
	    }
	
	    /* Attributes */
	    Object.defineProperties(this, {
	      start: { value: start },
	      end: { value: end }
	    });
	  }
	
	  /**
	   * <p>Highlight a range by wrapping one or more text nodes with a
	   * <code>span</code> tag and applying a particular CSS class.</p>
	   *
	   * @param {string} className - The CSS class name to apply. */
	
	
	  _createClass(Range, [{
	    key: "surround",
	    value: function surround(className) {
	      var _this = this;
	
	      /* Optimised case: highlighting does not span multiple nodes. */
	      if (this.start.marker.node === this.end.marker.node) {
	        this.surround_(this.start, this.start.offset, this.end.offset, className);
	        return;
	      }
	
	      /* Highlighting spans 2 or more nodes, which means we need to build a
	       * representation of all the text nodes contained in the start to end
	       * range, but excluding the start and end nodes. */
	      var visitor = new _textnodevisitor2.default(this.start.marker.node, this.content.root);
	      var end = this.end.marker.node;
	      var coll = [];
	
	      /* TODO: we assume `visitor.next()' will never return null because `end´ is
	       * within bounds. */
	      while (visitor.next() != end) {
	        coll.push(visitor.current);
	      } /* Apply highlighting to start and end nodes, and to any nodes in between,
	         * if applicable.  Highlighting for the start and end nodes may require
	         * text node truncation but not for the nodes in between. */
	      this.surround_(this.start, this.start.offset, null, className);
	      coll.forEach(function (n) {
	        return _this.surround_whole_(n, className);
	      });
	      this.surround_(this.end, 0, this.end.offset, className);
	    }
	
	    /**
	     * <p>Compute the XPath representation of the active range.</p>
	     * @returns {string} XPath representation of active range. */
	
	  }, {
	    key: "computeXpath",
	    value: function computeXpath() {
	      var start = this.start.marker.node;
	      var end = this.end.marker.node;
	      var computor = new _textnodexpath2.default(this.content.root);
	      return {
	        start: {
	          xpath: computor.xpathOf(start),
	          offset: this.start.offset + computor.offset(start)
	        },
	        end: {
	          xpath: computor.xpathOf(end),
	          offset: this.end.offset + computor.offset(end) + 1
	        }
	      };
	    }
	
	    /**
	     * <p>Compute the length of the active range.</p>
	     * @returns {number} Number of characters. */
	
	  }, {
	    key: "length",
	    value: function length() {
	      /* Optimised case: range does not span multiple nodes. */
	      if (this.start.marker.node === this.end.marker.node) {
	        return this.end.offset - this.start.offset + 1;
	      }
	
	      /* Range spans 2 or more nodes. */
	      var visitor = new _textnodevisitor2.default(this.start.marker.node, this.content.root);
	      var end = this.end.marker.node;
	      var length = this.start.marker.node.nodeValue.length - this.start.offset + this.end.offset + 1;
	
	      /* Add (whole) lengths of text nodes in between. */
	      while (visitor.next() != end) {
	        length += visitor.current.nodeValue.length;
	      }
	
	      return length;
	    }
	
	    /* Private interface
	     * ----------------- */
	    /**
	     * <p>Truncate text node into 2 or 3 text nodes and apply highlighting to
	     * relevant node, which is always the node referenced by
	     * <code>descr.marker.node</code>.</p>
	     *
	     * @param {Object} descr - Start or end <code>Range</code> descriptor.
	     * @param {number} start - Start offset.
	     * @param {number} end - End offset.
	     * @param {string} className - CSS class name to apply.
	     * */
	
	  }, {
	    key: "surround_",
	    value: function surround_(descr, start, end, className) {
	      this.content.truncate(descr.marker, start, end === null ? descr.marker.node.nodeValue.length - 1 : end);
	
	      (0, _jquery2.default)("<span/>").addClass(className).insertBefore(descr.marker.node).append(descr.marker.node);
	    }
	
	    /**
	     * Apply highlighting fully to a text node. No text node truncation occurs.
	     *
	     * @param {DOMElement} node - Text node to apply highlighting to.
	     * @param {string} className - CSS class name to apply.
	     * */
	
	  }, {
	    key: "surround_whole_",
	    value: function surround_whole_(node, className) {
	      (0, _jquery2.default)("<span/>").addClass(className).insertBefore(node).append(node);
	    }
	  }]);
	
	  return Range;
	}();
	
	exports.default = Range;

/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	var _util = __webpack_require__(2);
	
	var _range = __webpack_require__(4);
	
	var _range2 = _interopRequireDefault(_range);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	/**
	 * <p>Abstract base class of all finder classes.</p>
	 * @class
	 * @abstract
	 * @param {TextContent} content - reference to <code>TextContent</code>
	 * holding a text representation of the document.
	 * @param {*} subject - subject to find; can be of any type.
	 * */
	var Finder = function () {
	  function Finder(content) {
	    _classCallCheck(this, Finder);
	
	    Object.defineProperty(this, "content", { value: content });
	
	    this.results = [];
	    this.current = 0;
	  }
	
	  /**
	   * <p>Return next available match.  If no more matches available, returns
	   * <code>false</code>.</p>
	   * @abstract
	   *
	   * @returns {Range|false} Returns a <code>Range</code> if a match is
	   * available, or <code>false</code> if no more matches are available. */
	
	
	  _createClass(Finder, [{
	    key: "next",
	    value: function next() {
	      (0, _util.absm_noti)();
	    }
	
	    /* Protected interface
	     * ----------------- */
	    /**
	     * <p>Return a <code>Range</code> descriptor for a given offset.</p>
	     * @access private
	     *
	     * @param {number} offset - Text offset
	     * @returns {Object} Range descriptor. */
	
	  }, {
	    key: "getAt_",
	    value: function getAt_(offset) {
	      var index = this.content.indexOf(offset);
	      if (index === -1) {
	        throw new Error("Failed to retrieve marker for offset: " + offset);
	      }
	
	      return _range2.default.descriptorAbs(this.content.at(index), offset);
	    }
	  }]);
	
	  return Finder;
	}();
	
	exports.default = Finder;

/***/ },
/* 6 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	var _jquery = __webpack_require__(1);
	
	var _jquery2 = _interopRequireDefault(_jquery);
	
	var _consts = __webpack_require__(3);
	
	var _ui = __webpack_require__(10);
	
	var _ui2 = _interopRequireDefault(_ui);
	
	var _textcontent = __webpack_require__(14);
	
	var _textcontent2 = _interopRequireDefault(_textcontent);
	
	var _rangehighlighter = __webpack_require__(7);
	
	var _rangehighlighter2 = _interopRequireDefault(_rangehighlighter);
	
	var _rangeunhighlighter = __webpack_require__(13);
	
	var _rangeunhighlighter2 = _interopRequireDefault(_rangeunhighlighter);
	
	var _range = __webpack_require__(4);
	
	var _range2 = _interopRequireDefault(_range);
	
	var _cursor = __webpack_require__(12);
	
	var _cursor2 = _interopRequireDefault(_cursor);
	
	var _util = __webpack_require__(2);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	/**
	 * Main class of the HTML Highlighter module, which exposes an API enabling
	 * clients to control all the features supported related to highlighting and
	 * text selection.
	 * @class
	 * @param {Object} options - Map containing options
	 * */
	var HtmlHighlighter = function () {
	  function HtmlHighlighter(options) {
	    _classCallCheck(this, HtmlHighlighter);
	
	    /* Merge default options. */
	    options = _jquery2.default.extend(true, _jquery2.default.extend(true, {}, _consts.defaults), options);
	
	    /* Mutable properties. */
	    this.transaction = [];
	    this.queries = {};
	    this.highlights = [];
	    this.lastId = 0;
	    this.stats = {
	      queries: 0,
	      total: 0,
	      highlight: 0
	    };
	
	    if (!options.container) {
	      options.container = (0, _jquery2.default)(window.document.body);
	    } else if (options.container instanceof HTMLElement) {
	      options.container = (0, _jquery2.default)(options.container);
	    }
	
	    /* Define instance immutable properties. */
	    Object.defineProperty(this, "options", { value: options });
	    Object.defineProperty(this, "cursor", { value: new _cursor2.default(this) });
	    Object.defineProperty(this, "ui", { value: new _ui2.default(this, options) });
	    Object.defineProperty(this, "stats", { value: this.stats });
	
	    /* Start by refreshing the internal document's text representation. */
	    this.refresh();
	    console.info("HTML highlighter instantiated");
	  }
	
	  /**
	   * <p>Refreshes the internal representation of the text.</p>
	   *
	   * <p>Should only be invoked when the HTML structure mutates.</p>
	   */
	
	
	  _createClass(HtmlHighlighter, [{
	    key: "refresh",
	    value: function refresh() {
	      this.content = new _textcontent2.default(this.options.container.get(0));
	      if (HtmlHighlighter.debug === true) this.content.assert_();
	    }
	
	    /**
	     * <p>Create a query set by the name and containing one or more queries.  If
	     * the query set already exists, its contents and highlights are first
	     * destroyed and new one created.</p>
	     *
	     * <p>Note that, at this point in time, only string queries and XPath
	     * representations are supported.</p>
	     *
	     * @param {string} name - Name of the query set.
	     * @param {string[]} queries - Array containing individual queries to
	     * highlight.
	     * @param {bool} enabled - If explicitly <code>true</code>, query set is
	     * also enabled. */
	
	  }, {
	    key: "add",
	    value: function add(name, queries, enabled /* = false */, reserve /* = null */) {
	      this.transaction.push(function () {
	        this.deferred_add_(name, queries, enabled !== false, reserve);
	      }.bind(this));
	      return this;
	    }
	
	    /**
	     * <p>Append one or more queries to an existing query set.  If the query set
	     * doesn't yet exist, an exception is thrown.</p>
	     *
	     * <p>In addition, the query set <strong>must</strong> have enough reserved
	     * space available to contain the new queries.  All queries not fitting in
	     * the container are suppressed.</p>
	     *
	     * @param {string} name - Name of the query set.
	     * @param {string[]} queries - Array containing individual queries to
	     * highlight.
	     * @param {bool} enabled - If explicitly <code>true</code>, query set is
	     * also enabled. */
	
	  }, {
	    key: "append",
	    value: function append(name, queries, enabled /* = false */) {
	      this.transaction.push(function () {
	        this.deferred_append_(name, queries, enabled !== false);
	      }.bind(this));
	      return this;
	    }
	
	    /**
	     * <p>Remove a query set by name.</p>
	     *
	     * <p>An exception is thrown if the query set does not exist.</p>
	     *
	     * @param {string} name - Name of the query set to remove. */
	
	  }, {
	    key: "remove",
	    value: function remove(name) {
	      this.transaction.push(function () {
	        this.deferred_remove_(name);
	      }.bind(this));
	      return this;
	    }
	
	    /**
	     * <p>Enable a query set.</p>
	     *
	     * <p>An exception is thrown if the query set does not exist.  If the query
	     * set is currently already enabled, nothing is done.</p>
	     *
	     * @param {string} name - Name of the query set to enable. */
	
	  }, {
	    key: "enable",
	    value: function enable(name) {
	      this.transaction.push(function () {
	        this.deferred_enable_(name);
	      }.bind(this));
	      return this;
	    }
	
	    /**
	     * <p>Disable a query set.</p>
	     *
	     * <p>An exception is thrown if the query set does not exist.  If the query
	     * set is currently already disabled, nothing is done.</p>
	     *
	     * @param {string} name - Name of the query set to disable. */
	
	  }, {
	    key: "disable",
	    value: function disable(name) {
	      this.transaction.push(function () {
	        this.deferred_disable_(name);
	      }.bind(this));
	      return this;
	    }
	
	    /**
	     * Remove <strong>all</strong> query sets.
	     * */
	
	  }, {
	    key: "clear",
	    value: function clear() {
	      this.transaction.push(function () {
	        this.deferred_clear_();
	      }.bind(this));
	      return this;
	    }
	
	    /**
	     * <p>Apply transaction.</p>
	     *
	     * <p>Note that transactions are <strong>not</strong> atomic.  One failure
	     * does not lead to a transaction rollback or even interruption of
	     * execution; the transaction is applied regardless.</p> */
	
	  }, {
	    key: "apply",
	    value: function apply() {
	      if (this.transaction.length === 0) {
	        console.info("Nothing to apply: transaction queue empty");
	        return;
	      }
	
	      this.transaction.forEach(function (action) {
	        try {
	          action();
	        } catch (x) {
	          console.error("Failed to apply action: %s", x);
	        }
	      });
	
	      this.transaction = [];
	    }
	
	    /**
	     * <p>Set the queries that the cursor will visit when the <code>prev</code>
	     * and <code>next</code> methods are invoked.  If <code>null</code>, all
	     * queries will be visited. */
	
	  }, {
	    key: "setIterableQueries",
	    value: function setIterableQueries(queries) {
	      this.cursor.setIterableQueries(queries);
	      this.ui.update(false);
	    }
	
	    /**
	     * <p>Move cursor position to the next query in the active query set.  If the
	     * cursor moves past the last query in the active query set, the active query
	     * set moves to the next available one and the cursor position to its first
	     * query.  If the current query set is the last in the collection and thus it
	     * is not possible to move to the next query set, the first query set is made
	     * active instead, thus ensuring that the cursor always rolls over.</p> */
	
	  }, {
	    key: "next",
	    value: function next() {
	      /* Do not worry about overflow; just increment it. */
	      this.cursor.set(this.cursor.index + 1, false);
	      this.ui.update(false);
	    }
	
	    /**
	     * <p>Move cursor position to the previous query in the active query set.  If
	     * the cursor moves past the first query in the active query set, the active
	     * query set moves to the previous available one and the cursor position to
	     * its last query.  If the current query set is the first in the collection
	     * and thus it is not possible to move to the previous query set, the last
	     * query set is made active instead, thus ensuring that the cursor always
	     * rolls over.</p> */
	
	  }, {
	    key: "prev",
	    value: function prev() {
	      if (this.cursor.total <= 0) return;
	      this.cursor.set((this.cursor.index < 1 ? this.cursor.total : this.cursor.index) - 1, false);
	      this.ui.update(false);
	    }
	
	    /* eslint-disable complexity */
	    /**
	     * <p>Return the current selected text range in the form of a
	     * <code>Range</code> object.  If there is no selected text,
	     * <code>null</code> is returned.</p>
	     *
	     * @returns {Range|null} The current selected text range or <code>null</code>
	     * if it could not be computed. */
	
	  }, {
	    key: "getSelectedRange",
	    value: function getSelectedRange() {
	      var sel = window.getSelection();
	
	      if (!(sel && sel.anchorNode)) {
	        return null;
	      } else if (sel.anchorNode.nodeType !== 3 || sel.focusNode.nodeType !== 3) {
	        console.info("Selection anchor or focus node(s) not text: ignoring");
	        return null;
	      }
	
	      /* Account for selections where the start and end elements are the same
	       * *and* whitespace exists longer than one character.  For instance, The
	       * element `<p>a     b</p>` is shown as `a b` by browsers, where the
	       * whitespace is rendered collapsed.  This means that in this particular
	       * case, it is not possible to simply retrieve the length of the
	       * selection's text and use that as the selection's end offset as it would
	       * be invalid.  The way to avoid calculating an invalid end offset is by
	       * looking at the anchor and focus (start and end) offsets.  Strangely, if
	       * the selection spans more than one element, one may simply use the length
	       * of the selected text regardless of the occurrence of whitespace in
	       * between. */
	      var len = sel.anchorNode === sel.focusNode ? sel.focusOffset - sel.anchorOffset : sel.toString().length;
	      if (len <= 0) return null;
	
	      /* Determine start and end indices in text offset markers array. */
	      var start = this.content.find(sel.anchorNode),
	          end = sel.focusNode === sel.anchorNode ? start : this.content.find(sel.focusNode);
	
	      if (start < 0 || end < 0) {
	        console.error("Unable to retrieve offset of selection anchor or focus" + "node(s)", sel.anchorNode, sel.focusNode);
	        return null;
	      }
	
	      /* Create start and end range descriptors, whilst accounting for inverse
	       * selection where the user selects text in a right to left orientation. */
	      if (start < end || start === end && sel.anchorOffset < sel.focusOffset) {
	        start = _range2.default.descriptorRel(this.content.at(start), sel.anchorOffset);
	
	        if (sel.focusNode === sel.anchorNode) {
	          end = _jquery2.default.extend(true, {}, start);
	          end.offset = start.offset + len - 1;
	        } else {
	          end = _range2.default.descriptorRel(this.content.at(end), sel.focusOffset - 1);
	        }
	      } else {
	        start = _range2.default.descriptorRel(this.content.at(end), sel.focusOffset);
	
	        if (sel.focusNode === sel.anchorNode) {
	          end = _jquery2.default.extend(true, {}, start);
	          end.offset = end.offset + len - 1;
	        } else {
	          end = _range2.default.descriptorRel(this.content.at(start), sel.anchorOffset - 1);
	        }
	      }
	
	      return new _range2.default(this.content, start, end);
	    }
	    /* eslint-enable complexity */
	
	    /**
	     * <p>Clear the current text selection, if any.</p>
	     *
	     * <p>Only the Chrome and Firefox implementations are supported.</p>
	     * */
	
	  }, {
	    key: "clearSelectedRange",
	    value: function clearSelectedRange() {
	      /* From: http://stackoverflow.com/a/3169849/3001914
	       * Note that we don't support IE at all. */
	      if (window.getSelection) {
	        if (window.getSelection().empty) {
	          /* Chrome */
	          window.getSelection().empty();
	        } else if (window.getSelection().removeAllRanges) {
	          /* Firefox */
	          window.getSelection().removeAllRanges();
	        }
	      }
	    }
	
	    /**
	     * <p>Return boolean indicative of whether one or more query sets are
	     * currently contained.</p>
	     *
	     * @returns {boolean} <code>false</code> if no query sets currently
	     * contained; <code>true</code> otherwise. */
	
	  }, {
	    key: "empty",
	    value: function empty() {
	      var _this = this;
	
	      return Object.keys(this.queries).some(function (k) {
	        return _this.queries[k].length > 0;
	      });
	    }
	
	    /**
	     * <p>Return the last id of a query set.</p>
	     *
	     * @param {string} name - the name of the query set.
	     * @returns {number} the last id or <code>-1</code> if query set empty.
	     * */
	
	  }, {
	    key: "lastIdOf",
	    value: function lastIdOf(name) {
	      var q = this.get_(name);
	      var l = q.length;
	      return l > 0 ? q.id + l - 1 : -1;
	    }
	
	    /* Private interface
	     * ----------------- */
	    /**
	     * <p>Add or append queries to a query set, either enabled or disabled.</p>
	     *
	     * @param {string} name - the name of the query set.
	     * @param {Object} q - query set descriptor.
	     * @param {Array} queries - array containing the queries to add or append.
	     * @param {boolean} enabled - highlights are enabled if <code>true</code>;
	     * this is the default state.
	     *
	     * @returns {number} number of highlights added.
	     * */
	
	  }, {
	    key: "add_queries_",
	    value: function add_queries_(name, q, queries, enabled) {
	      var content = this.content;
	      var markers = this.highlights;
	      var reserve = q.reserve > 0 ? q.reserve - q.length : null;
	
	      var count = 0,
	          csscl = null;
	
	      if (this.options.useQueryAsClass) csscl = _consts.Css.highlight + "-" + name;
	      var highlighter = new _rangehighlighter2.default(q.id_highlight, q.id + q.length, enabled, csscl);
	
	      /* For each query, perform a lookup in the internal text representation and
	       * highlight each hit.  The global offset of each highlight is recorded in
	       * the `this.highlights´ array.  The offset is used by the `Cursor´ class
	       * to compute the next/previous highlight to show. */
	      queries.forEach(function (i) {
	        var hit = void 0,
	            finder = void 0;
	
	        try {
	          finder = (0, _util.constructFinder)(content, i);
	        } catch (x) {
	          console.error("exception: ", x);
	          return;
	        }
	
	        if (hit === false) {
	          console.info("Query has no hits: ", i);
	          return;
	        }
	
	        /* Note: insertion of global offsets to the `this.highlights` array could
	         * (should?) be done in a web worker concurrently. */
	        while ((hit = finder.next()) !== false) {
	          if (reserve !== null && count >= reserve) {
	            console.error("highlight reserve exceeded");
	            break;
	          }
	
	          var offset = hit.start.marker.offset + hit.start.offset;
	          var mid = void 0;
	          var min = 0,
	              max = markers.length - 1;
	
	          while (min < max) {
	            mid = Math.floor((min + max) / 2);
	
	            if (markers[mid].offset < offset) min = mid + 1;else max = mid;
	          }
	
	          markers.splice(markers.length > 0 && markers[min].offset < offset ? min + 1 : min, 0, { query: q, index: count, offset: offset });
	
	          try {
	            highlighter.do(hit);
	            ++count;
	          } catch (x) {
	            console.error("exception: ", x);
	          }
	        }
	      });
	
	      q.length += count;
	      if (enabled) this.stats.total += count;
	      return count;
	    }
	
	    /**
	     * <p>Remove a query set by name.</p>
	     *
	     * <p>Throws an exception if the query set does not exist.</p>
	     * @access private
	     *
	     * @param {string} name - The name of the query set to remove. */
	
	  }, {
	    key: "remove_",
	    value: function remove_(name) {
	      var q = this.get_(name);
	      var markers = this.highlights;
	      var unhighlighter = new _rangeunhighlighter2.default();
	
	      --this.stats.queries;
	      this.stats.total -= q.length;
	
	      for (var i = q.id, l = i + q.length; i < l; ++i) {
	        unhighlighter.undo(i);
	      }
	
	      for (var _i = 0; _i < markers.length;) {
	        if (markers[_i].query === q) markers.splice(_i, 1);else ++_i;
	      }
	
	      delete this.queries[name];
	
	      /* TODO: Unfortunately, using the built-in `normalize` `HTMLElement` method
	       * to normalise text nodes means we have to refresh the offsets of the text
	       * nodes, which may not be desirable.  There must be a better way. */
	      if (this.options.normalise) {
	        this.options.container.get(0).normalize();
	        this.refresh();
	      }
	    }
	
	    /**
	     * <p>Safely retrieve a query set's descriptor.</p>
	     *
	     * <p>Throws an exception if the query set does not exist.</p>
	     *
	     * @param {string} name - The name of the query set to retrieve. */
	
	  }, {
	    key: "get_",
	    value: function get_(name) {
	      var q = this.queries[name];
	      if (q === undefined) throw new Error("Query set non-existent");
	      return q;
	    }
	  }, {
	    key: "assert_",
	    value: function assert_() {
	      var _this2 = this;
	
	      var k = void 0;
	      var c = 0,
	          l = 0;
	
	      Object.keys(this.queries).forEach(function (k) {
	        return l += _this2.queries[k].length;
	      });
	
	      k = 0;
	      this.highlights.forEach(function (i) {
	        if (i.offset < c || i.index >= i.query.length) throw new Error("Invalid state: highlight out of position");
	
	        c = i.offset;
	        ++k;
	      });
	
	      if (k !== l) throw new Error("Invalid state: length mismatch");
	    }
	  }, {
	    key: "deferred_add_",
	    value: function deferred_add_(name, queries, enabled, reserve) {
	      if (!(0, _util.is_arr)(queries)) {
	        throw new Error("Invalid or no queries array specified");
	      }
	
	      enabled = enabled === true;
	      if (typeof reserve !== "number" || reserve < 1) reserve = null;
	
	      /* Remove query set if it exists. */
	      if (name in this.queries) this.deferred_remove_(name);
	
	      var q = this.queries[name] = {
	        name: name,
	        enabled: enabled,
	        id_highlight: this.stats.highlight,
	        id: this.lastId,
	        length: 0
	      };
	
	      var count = this.add_queries_(name, q, queries, enabled);
	      if (reserve !== null) {
	        if (reserve > count) {
	          this.lastId = reserve;
	          q.reserve = reserve;
	        } else {
	          console.error("Invalid or insufficient reserve specified");
	          q.reserve = count;
	        }
	      } else {
	        this.lastId += count;
	      }
	
	      /* Update global statistics. */
	      ++this.stats.queries;
	
	      /* Ensure CSS highlight class rolls over on overflow. */
	      ++this.stats.highlight;
	      if (this.stats.highlight >= this.options.maxHighlight) {
	        this.stats.highlight = 0;
	      }
	
	      this.cursor.clear();
	      this.ui.update();
	      if (HtmlHighlighter.debug === true) this.assert_();
	    }
	  }, {
	    key: "deferred_append_",
	    value: function deferred_append_(name, queries, enabled) {
	      if (!(0, _util.is_arr)(queries)) {
	        throw new Error("Invalid or no queries array specified");
	      } else if (!(name in this.queries)) {
	        throw new Error("Invalid or query set not yet created");
	      }
	
	      this.add_queries_(name, this.queries[name], queries, enabled === true);
	      this.cursor.clear();
	      this.ui.update();
	      if (HtmlHighlighter.debug === true) this.assert_();
	    }
	  }, {
	    key: "deferred_remove_",
	    value: function deferred_remove_(name) {
	      this.remove_(name);
	      this.cursor.clear();
	      this.ui.update();
	    }
	  }, {
	    key: "deferred_enable_",
	    value: function deferred_enable_(name) {
	      var q = this.get_(name);
	      if (q.enabled || q.id === null) return;
	
	      for (var i = q.id, l = i + q.length; i < l; ++i) {
	        (0, _jquery2.default)("." + _consts.Css.highlight + "-id-" + i).removeClass(_consts.Css.disabled);
	      }
	
	      q.enabled = true;
	      this.stats.total += q.length;
	      this.cursor.clear();
	      this.ui.update(false);
	    }
	  }, {
	    key: "deferred_disable_",
	    value: function deferred_disable_(name) {
	      var q = this.get_(name);
	      if (!q.enabled || q.id === null) return;
	
	      for (var i = q.id, l = i + q.length; i < l; ++i) {
	        (0, _jquery2.default)("." + _consts.Css.highlight + "-id-" + i).addClass(_consts.Css.disabled);
	      }
	
	      q.enabled = false;
	      this.stats.total -= q.length;
	      this.cursor.clear();
	      this.ui.update(false);
	    }
	  }, {
	    key: "deferred_clear_",
	    value: function deferred_clear_() {
	      var _this3 = this;
	
	      Object.keys(this.queries).forEach(function (k) {
	        return _this3.remove_(k);
	      });
	
	      if (!(0, _util.is_obj_empty)(this.queries)) {
	        throw new Error("Query set object not empty");
	      }
	
	      this.cursor.clear();
	      this.ui.update();
	    }
	  }]);
	
	  return HtmlHighlighter;
	}();
	
	/** Static attribute that sets the debug state for methods that don't have
	 * access to the `options` descriptor and thus can't query the `debug`
	 * attribute. */
	
	
	HtmlHighlighter.debug = false;
	
	exports.default = HtmlHighlighter;

/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _consts = __webpack_require__(3);
	
	/**
	 * <p>Convenience class for applying highlighting on <code>Range</code>
	 * instances.</p>
	 * @class
	 * @param {number} count - The CSS highlight class index to use.
	 * @param {number} id - The individual id to apply to the highlight.
	 * @param {bool} enabled - If explicitly <code>false</code>, highlights are
	 * created but not shown. */
	var RangeHighlighter = function RangeHighlighter(count, id, enabled, cssClass) {
	  var classes = [_consts.Css.highlight, _consts.Css.highlight + "-" + count];
	
	  if (cssClass) classes.push(cssClass);
	  if (enabled === false) classes.push(_consts.Css.disabled);
	  classes = classes.join(" ");
	
	  /**
	   * <p>Highlight a <code>Range</code> instance.</p>
	   *
	   * @param {Range} range - Range instance to apply highlighting to.
	   * @returns {number} Unique highlight id. */
	  this.do = function (range) {
	    range.surround(classes + " " + _consts.Css.highlight + "-id-" + id);
	    return id++;
	  };
	};
	
	exports.default = RangeHighlighter;

/***/ },
/* 8 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	var _jquery = __webpack_require__(1);
	
	var _jquery2 = _interopRequireDefault(_jquery);
	
	var _finder = __webpack_require__(5);
	
	var _finder2 = _interopRequireDefault(_finder);
	
	var _range = __webpack_require__(4);
	
	var _range2 = _interopRequireDefault(_range);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }
	
	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
	
	/**
	 * <p>Class responsible for finding text in a <code>TextContent</code>
	 * instance.</p>
	 * @class
	 *
	 * @param {TextContent} content - Reference to <code>TextContent</code>
	 * instance.
	 * @param {string} subject - Subject string to match. */
	/* FIXME: create a class for matching of regular expression subjects. */
	var TextFinder = function (_Finder) {
	  _inherits(TextFinder, _Finder);
	
	  function TextFinder(content, subject) {
	    _classCallCheck(this, TextFinder);
	
	    /* Build an array containing all hits of `subject´. */
	    var _this = _possibleConstructorReturn(this, (TextFinder.__proto__ || Object.getPrototypeOf(TextFinder)).call(this, content));
	    /* Construct base class. */
	
	
	    var match = void 0;
	    var re = subject instanceof RegExp ? subject : new RegExp(subject.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&"), "gi");
	
	    while ((match = re.exec(_this.content.text)) !== null) {
	      _this.results.push({ length: match[0].length, index: match.index });
	    }
	    return _this;
	  }
	
	  /**
	   * <p>Return next available match.</p>
	   *
	   * @returns {Range|false} Returns a <code>Range</code> if a match is
	   * available, or <code>false</code> if no more matches are available. */
	
	
	  _createClass(TextFinder, [{
	    key: "next",
	    value: function next() {
	      if (this.current >= this.results.length) return false;
	
	      var match = this.results[this.current];
	      var length = match.length;
	      var start = this.getAt_(match.index);
	      var end = void 0;
	
	      /* Re-use start marker descriptor if end offset within bounds of start text
	       * node. */
	      if (start.offset + length <= start.marker.node.nodeValue.length) {
	        end = _jquery2.default.extend({}, start);
	        end.offset = start.offset + length - 1;
	      } else {
	        end = this.getAt_(match.index + length - 1);
	      }
	
	      var range = new _range2.default(this.content, start, end);
	      ++this.current;
	
	      return range;
	    }
	  }]);
	
	  return TextFinder;
	}(_finder2.default);
	
	exports.default = TextFinder;

/***/ },
/* 9 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	var _consts = __webpack_require__(3);
	
	var _util = __webpack_require__(2);
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	/**
	 * <p>This class builds XPath representations of text nodes, optionally
	 * within a DOM sub-tree.  If a root node is specified, the XPath produced
	 * will include the elements up to but <strong>not</strong> including said
	 * root node.</p>
	 * @class
	 * @param {DOMElement} [root=null] - Root DOM node. */
	var TextNodeXpath = function () {
	  function TextNodeXpath(root) {
	    _classCallCheck(this, TextNodeXpath);
	
	    this.root = root || null;
	    if ((0, _util.is_$)(this.root)) this.root = this.root.get(0);
	  }
	
	  /**
	   * <p>Compute the XPath representation of a text node.</p>
	   *
	   * <p>The XPath produced of the text node is fully normalised and unaffected
	   * by the current state of text node fragmentation caused by the presence of
	   * highlight containers.</p>
	   *
	   * <p>Throws an exception if <code>node</code> is <strong>not</strong> a text
	   * node.</p>
	   *
	   * @param {DOMElement} node - Text node to compute XPath representation of.
	   * @returns {string} XPath representation. */
	
	
	  _createClass(TextNodeXpath, [{
	    key: "xpathOf",
	    value: function xpathOf(node) {
	      /* Note: no checks required since `indexOfText_´ throws exception if node
	       * invalid: null or not like text. */
	      var xpath = "/text()[" + this.indexOfText_(node) + "]";
	
	      /* Skip all text or highlight container nodes. */
	      for (node = node.parentNode; node !== null && node !== this.root && this.isLikeText_(node); node = node.parentNode) {}
	
	      /* Start traversing upwards from `node´'s parent node until we hit `root´
	       * (or null). */
	      for (; node !== null && node !== this.root && node.nodeType === 1; node = node.parentNode) {
	        var id = this.indexOfElement_(node);
	        xpath = "/" + node.nodeName.toLowerCase() + "[" + id + "]" + xpath;
	      }
	
	      /* This is bad.  Lay off the LSD. */
	      if (node === null) {
	        throw new Error("Specified node not within root's subtree");
	      }
	
	      return xpath;
	    }
	
	    /**
	     * <p>Compute element referenced by an XPath string.</p>
	     *
	     * <p>The element computed is the same that would result from traversing a
	     * DOM sub-tree fully normalised and thus unaffected by text node
	     * fragmentation caused by the presence of highlight containers.</p>
	     *
	     * @param {string} xpath - String containing XPath representation.
	     * @returns {DOMElement} The element referenced by the XPath string.
	     * */
	
	  }, {
	    key: "elementAt",
	    value: function elementAt(xpath) {
	      var parts = xpath.split("/");
	      var part = void 0;
	      var cur = this.root; /* start from the root node */
	
	      /* At an absolutely minimum, a XPath representation must be of the form:
	       * /text(), which results in `parts´ having a length of 2. */
	      if (parts[0].length !== 0 || parts.length < 2) {
	        throw new Error("Invalid XPath representation");
	      }
	
	      /* Break up the constituent parts of the XPath representation but discard
	       * the first element since it'll be empty due to the starting forward
	       * slash in the XPath string. */
	      var i = 1;
	      for (var l = parts.length - 1; i < l; ++i) {
	        part = this.xpathPart_(parts[i]);
	        cur = this.nthElementOf_(cur, part.tag, part.index);
	        if (cur === null) {
	          /* This, we would hope, would be indicative that the tree mutated.
	           * Otherwise, either this algorithm is flawed or the reverse operation
	           * is. */
	          console.error("Failed to find nth child:", part, cur);
	          return null;
	        }
	      }
	
	      /* Now process the text element given by `parts[i]`. */
	      part = this.xpathPart_(parts[i]);
	      cur = part.tag === "text()" ? this.nthTextOf_(cur, part.index) : null;
	
	      if (cur === null || cur.nodeType !== 3) {
	        console.error("Element at specified XPath NOT a text node: %s", xpath, part, cur);
	        return null;
	      }
	
	      return cur;
	    }
	
	    /**
	     * <p>Calculate the relative offset from a specified text node
	     * (<code>node</code>) to the start of the first <strong>sibling</strong>
	     * text node in a set of contiguous text or highlight container nodes.</p>
	     *
	     * <p>For example, given the post-highlight, non-normalised, child contents
	     * of an arbitrary element:</p>
	     *
	     * <pre><code>#text + SPAN.hh-highlight + #text + STRONG</code></pre>
	     *
	     * <p>If this method were invoked with <code>node<code> containing a
	     * reference to the third <code>#text</code> element, the computed offset
	     * would be the length of the <code>SPAN</code> to its left plus the length
	     * of the first <code>#text</code>.  This because the normalised version --
	     * pre-highlight, that is -- of the above would be:</p>
	     *
	     * <pre><code>#text + STRONG</code></pre> */
	
	  }, {
	    key: "offset",
	    value: function offset(node) {
	      var offset = 0;
	
	      if (!node || node.nodeType !== 3) {
	        throw new Error("Invalid or no text node specified");
	      }
	
	      /* eslint-disable no-constant-condition */
	      /* Climb the tree of nested highlight containers in a left to right
	       * order, if any, calculating their respective lengths and adding to the
	       * overall offset. */
	      while (true) {
	        while (node.previousSibling === null) {
	          node = node.parentNode;
	          if (node === this.root || node === null) {
	            throw new Error("Invalid state: expected highlight container or text node");
	          } else if (!this.isHighlight_(node)) {
	            return offset;
	          } else if (node.previousSibling !== null) {
	            break;
	          }
	        }
	
	        node = node.previousSibling;
	        if (!this.isLikeText_(node)) break;
	
	        offset += this.length_(node);
	      }
	      /* eslint-enable no-constant-condition */
	
	      return offset;
	    }
	
	    /**
	     * <p>Calculate the length of all text nodes in a specified sub-tree.</p>
	     *
	     * <p>Note that no checks are made to ensure that the node is either a
	     * highlight container or text node.  Caller is responsible for invoking this
	     * method in the right context.</p>
	     *
	     * @access private
	     * @param {DOMElement} node - text node or <strong>highlight</strong>
	     * container
	     * @returns {integer} Combined length of text nodes.
	     * */
	
	  }, {
	    key: "length_",
	    value: function length_(node) {
	      if (node.nodeType === 3) return node.nodeValue.length;
	
	      /* If `node´ isn't of text type, it is *assumed* to be a highlight
	       * container.  No checks are made to ensure this is the case.  Caller is
	       * responsible! */
	      var ch = node.childNodes;
	      var length = 0;
	
	      /* We loop recursively through all child nodes because a single highlight
	       * container may be parent to multiple highlight containers. */
	      for (var i = 0, l = ch.length; i < l; ++i) {
	        length += this.length_(ch[i]);
	      }
	
	      return length;
	    }
	
	    /**
	     * <p>Skip to first highlight container parent of a specified node, if it is
	     * of text type.</p>
	     *
	     * @param {DOMElement} node - text node.
	     * @returns {DOMElement} First highlight container of text node, if
	     * applicable. */
	
	  }, {
	    key: "skip_",
	    value: function skip_(node) {
	      /* Don't do anything if node isn't of text type. */
	      if (node.nodeType === 3) {
	        /* eslint-disable no-constant-condition */
	        while (true) {
	          /* Skip to first highlight container element. */
	          var parent = node.parentNode;
	          if (parent === this.root || !this.isHighlight_(parent)) break;
	          node = parent;
	        }
	        /* eslint-enable no-constant-condition */
	      }
	
	      return node;
	    }
	
	    /**
	     * <p>Return boolean value indicative of whether a given node is a highlight
	     * container.</p>
	     * @access private
	     *
	     * @param {DOMElement} node - DOM element to check
	     * @returns {boolean} <code>true</code> if it is a highlight container. */
	
	  }, {
	    key: "isHighlight_",
	    value: function isHighlight_(node) {
	      /* NOTE: this is potentially problematic if the document uses class names
	       * that contain or are equal to `Css.highlight´. */
	      return node.nodeName.toLowerCase() === "span" && node.className.indexOf(_consts.Css.highlight) !== -1;
	    }
	
	    /**
	     * <p>Return the XPath index of an arbitrary element node, excluding text
	     * nodes, relative to its sibling nodes.</p>
	     *
	     * <p>Note that XPath indices are <strong>not</strong> zero-based.</p>
	     *
	     * @access private
	     * @param {DOMElement} node - DOM element to calculate index of.
	     * @returns {number} Index of node plus one. */
	
	  }, {
	    key: "indexOfElement_",
	    value: function indexOfElement_(node) {
	      var name = node.nodeName.toLowerCase();
	      var index = 1;
	
	      if (node === null || this.isLikeText_(node)) {
	        throw new Error("No node specified or node of text type");
	      }
	
	      while ((node = node.previousSibling) !== null) {
	        /* Don't count contiguous text nodes or highlight containers as being
	         * separate nodes.  IOW, contiguous text nodes or highlight containers
	         * are treated as ONE element. */
	        if (!this.isLikeText_(node) && node.nodeName.toLowerCase() === name) {
	          ++index;
	        }
	      }
	
	      return index;
	    }
	
	    /**
	     * <p>Return the XPath index of an arbitrary <strong>text</strong> node,
	     * excluding element nodes, relative to its sibling nodes.  Since text nodes
	     * are liable to be truncated to enable highlight of a substring of text,
	     * this method counts contiguous text nodes and highlight container elements
	     * as one, e.g.:</p>
	     *
	     * <pre>
	     * #text + STRONG + #text + SPAN.highlight
	     * </pre>
	     *
	     * <p>In the example above, the index of the third node is the same as the
	     * fourth node's, or 3.  More clearly:</p>
	     *
	     * <pre>
	     * 1, 2, 3, 3
	     * </pre>
	     *
	     * <p>Note that XPath indices are <strong>not</strong> zero-based.</p>
	     *
	     * @access private
	     * @param {DOMElement} node - DOM element to calculate index of.
	     * @returns {number} Index of node plus one. */
	
	  }, {
	    key: "indexOfText_",
	    value: function indexOfText_(node) {
	      var index = 1,
	          wast = true;
	
	      if (node === null || !this.isLikeText_(node)) {
	        throw new Error("No node specified or not of text type");
	      }
	
	      node = this.skip_(node);
	      while ((node = node.previousSibling) !== null) {
	        /* Don't count contiguous text nodes or highlight containers as being
	         * separate nodes.  IOW, contiguous text nodes or highlight containers
	         * are treated as ONE element. */
	        if (this.isLikeText_(node)) {
	          if (wast) continue;else wast = true;
	          ++index;
	        } else wast = false;
	      }
	
	      return index;
	    }
	
	    /**
	     * <p>Return <code>true</code> if specified node is either of text type or a
	     * highlight container, thus like a text node.</p>
	     *
	     * @param {DOMElement} node - node to check
	     * @returns */
	
	  }, {
	    key: "isLikeText_",
	    value: function isLikeText_(node) {
	      return node.nodeType === 3 || this.isHighlight_(node);
	    }
	
	    /**
	     * <p>Return an object map containing a tag and index of an XPath
	     * representation <i>part</i>.</p>
	     *
	     * <p>Exceptions may be thrown if the regular expression matcher encounters
	     * an unrecoverable error of if the index in the XPath <i>part</i> is less
	     * than 1.</p>
	     *
	     * <p>Object returned is of the form:</p>
	     * <pre>{
	     *   tag: string,
	     *   index: integer
	     * }</pre>
	     *
	     * @param {string} part - An XPath representation part; e.g. "div[2]",
	     * "text()[3]" or "p"
	     * @returns {Object} Object containing tag and index */
	
	  }, {
	    key: "xpathPart_",
	    value: function xpathPart_(part) {
	      var index = void 0;
	
	      /* If no index specified: assume first. */
	      if (part.indexOf("[") === -1) {
	        return { tag: part.toLowerCase(), index: 0 };
	      }
	
	      /* *Attempt* to retrieve element's index.  If an exception is thrown,
	       * produce a meaningful error but re-throw since the XPath
	       * representation is clearly invalid. */
	      try {
	        part = part.match(/([^[]+)\[(\d+)\]/);
	        index = parseInt(part[2]);
	        part = part[1];
	        if (--index < 0) throw new Error("Invalid index: " + index);
	      } catch (x) {
	        console.error("Failed to extract child index: %s", part);
	        throw x; /* Re-throw after dumping inspectable object. */
	      }
	
	      return { tag: part.toLowerCase(), index: index };
	    }
	
	    /**
	     * <p>Find the nth child element of a specified node,
	     * <strong>excluding</strong> text nodes.</p>
	     *
	     * @param {DOMElement} parent - node whose children to search
	     * @param {string} tag - the tag name of the node sought in
	     * <strong>lowercase</strong> form
	     * @param {integer} index - child index of the node sought
	     *
	     * @returns {DOMElement} The nth element of <code>node</code> */
	
	  }, {
	    key: "nthElementOf_",
	    value: function nthElementOf_(parent, tag, index) {
	      var ch = parent.children;
	      var node = void 0;
	
	      for (var i = 0, l = ch.length; i < l; ++i) {
	        node = ch[i];
	
	        /* Skip highlight containers since tag could be `span´, the same as
	         * highlight containers. */
	        if (this.isHighlight_(node)) {
	          continue;
	        } else if (node.nodeName.toLowerCase() === tag) {
	          if (index === 0) return node;
	          --index;
	        }
	      }
	
	      console.error("Failed to locate tag '%s' at index %d", tag, index);
	      return null;
	    }
	
	    /**
	     * <p>Find the nth normalised text node within a specified element node.</p>
	     *
	     * @param {DOMElement} parent - node whose children to search
	     * @param {string} tag - the tag name of the node sought
	     * @param {integer} index - child index of the node sought */
	
	  }, {
	    key: "nthTextOf_",
	    value: function nthTextOf_(parent, index) {
	      var node = void 0;
	      var wast = false,
	          ch = parent.childNodes;
	
	      for (var i = 0, l = ch.length; i < l; ++i) {
	        node = ch[i];
	
	        /* Don't count contiguous text or highlight container nodes and ignore
	         * non-text nodes. */
	        if (this.isLikeText_(node)) {
	          if (wast) continue;else wast = true;
	        } else {
	          wast = false;continue;
	        }
	
	        /* We have got a potential match when `index´ === 0 . */
	        if (index === 0) {
	          /* Skip to first text node if currently on a highlight container. */
	          while (this.isHighlight_(node)) {
	            ch = node.childNodes;
	            if (ch.length === 0 || !this.isLikeText_(ch[0])) {
	              throw new Error("Invalid state: expected text node or highlight container" + " inside container");
	            }
	
	            node = ch[0];
	          }
	
	          /* Ensure tag sought after is the right one. */
	          if (node.nodeType !== 3) {
	            console.error("Failed to locate text node at index %d", index);
	            return null;
	          }
	
	          return node;
	        }
	
	        --index;
	      }
	
	      /* No match! */
	      return null;
	    }
	  }]);
	
	  return TextNodeXpath;
	}();
	
	exports.default = TextNodeXpath;

/***/ },
/* 10 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	var _jquery = __webpack_require__(1);
	
	var _jquery2 = _interopRequireDefault(_jquery);
	
	var _consts = __webpack_require__(3);
	
	var _templatefinder = __webpack_require__(18);
	
	var _templatefinder2 = _interopRequireDefault(_templatefinder);
	
	var _nodefinder = __webpack_require__(16);
	
	var _nodefinder2 = _interopRequireDefault(_nodefinder);
	
	var _util = __webpack_require__(2);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	/**
	 * <p>Class responsible for updating the user interface widget, if one is
	 * supplied.</p>
	 *
	 * @class
	 * @param {Main} owner - reference to owning <code>Main</code> instance
	 * @param {Object} options - map containing options
	 * */
	var Ui = function () {
	  function Ui(owner, options) {
	    var _this = this;
	
	    _classCallCheck(this, Ui);
	
	    this.owner = owner;
	
	    if (!(0, _util.is_$)(options.widget)) {
	      console.warn("HTML highlighter UI unavailable");
	      Object.defineProperty(this, "options", { value: false });
	      return;
	    }
	
	    Object.defineProperty(this, "options", { value: options });
	
	    var finder = new _nodefinder2.default("data-hh-scope", "", options.widget);
	
	    this.root = finder.root;
	    this.nodes = {
	      statsCurrent: finder.find("stats-current"),
	      statsTotal: finder.find("stats-total"),
	      next: finder.find("button-next"),
	      prev: finder.find("button-prev"),
	      expander: finder.find("expand"),
	      entities: finder.find("entities")
	    };
	
	    finder = new _templatefinder2.default("text/hh-template", "data-hh-scope");
	    this.templates = {
	      entityRow: finder.find("entity-row"),
	      entityEmpty: finder.find("entity-empty")
	    };
	
	    this.timeouts = {};
	
	    this.nodes.expander.click(function () {
	      var el = _this.nodes.entities;
	      el.toggleClass(_consts.Css.enabled);
	
	      if ("entities" in _this.timeouts) {
	        window.clearTimeout(_this.timeouts.entities);
	        _this.timeouts.entities = null;
	      }
	
	      if (el.hasClass(_consts.Css.enabled)) {
	        _this.timeouts.entities = window.setTimeout(function () {
	          el.css("overflow-y", "auto");
	          _this.timeouts.entities = null;
	        }, _this.options.delays.toggleEntities);
	
	        _this.nodes.expander.addClass(_consts.Css.enabled);
	      } else {
	        el.css("overflow-y", "hidden");
	        _this.nodes.expander.removeClass(_consts.Css.enabled);
	      }
	    });
	
	    this.nodes.entities.click(function (ev) {
	      var $node = (0, _jquery2.default)(ev.target);
	      if ($node.data("hh-scope") === "remove") {
	        _this.owner.remove(_this.getName_($node)).apply();
	      }
	    });
	
	    this.nodes.next.click(function () {
	      return _this.owner.next();
	    });
	    this.nodes.prev.click(function () {
	      return _this.owner.prev();
	    });
	
	    /* Initial empty state. */
	    this.setEmpty_();
	    this.update();
	
	    console.info("HTML highlighter UI instantiated");
	  }
	
	  /**
	   * <p>Update the UI state.</p>
	   *
	   * <p>Does a full or partial update of the UI state.  A full update is done if
	   * <code>full</code> is either unspecified (<code>undefined</code>) or
	   * <code>true</code>, and consists of refreshing the query set list as well
	   * as the cursor position and total.  A partial update merely refreshes
	   * the cursor position and total.</p>
	   *
	   * @param {boolean} full - specifies whether to do a full update
	   * */
	
	
	  _createClass(Ui, [{
	    key: "update",
	    value: function update(full) {
	      var _this2 = this;
	
	      if (!this.options) return false;
	
	      this.nodes.statsCurrent.html(this.owner.cursor.index >= 0 ? this.owner.cursor.index + 1 : "-");
	      this.nodes.statsTotal.html(this.owner.cursor.total);
	
	      if (full === false || this.templates.entityRow === null) {
	        return;
	      } else if ((0, _util.is_obj_empty)(this.owner.queries)) {
	        this.setEmpty_();
	        return;
	      }
	
	      /* Template `entity-row´ must supply an LI element skeleton. */
	      var $elu = (0, _jquery2.default)("<ul/>");
	
	      Object.keys(this.owner.queries).forEach(function (k) {
	        var q = _this2.owner.queries[k];
	        var $eli = _this2.templates.entityRow.clone();
	
	        if (q.enabled) $eli.find("enable").prop("checked", true);
	
	        $eli.find("name").text(k);
	        $eli.find("count").text(q.length);
	        $elu.append($eli.get());
	      });
	
	      $elu.click(function (ev) {
	        var $node = (0, _jquery2.default)(ev.target);
	        if ($node.data("hh-scope") === "enable") {
	          if ($node.prop("checked")) _this2.owner.enable(_this2.getName_($node));else _this2.owner.disable(_this2.getName_($node));
	
	          _this2.owner.apply();
	        }
	      });
	
	      this.nodes.entities.children().remove();
	      this.nodes.entities.append($elu);
	    }
	  }, {
	    key: "getName_",
	    value: function getName_($node) {
	      return $node.parentsUntil("ul").last().find('[data-hh-scope="name"]').text();
	    }
	  }, {
	    key: "setEmpty_",
	    value: function setEmpty_() {
	      this.nodes.entities.children().remove();
	      if (this.templates.entityEmpty !== null) {
	        this.nodes.entities.append(this.templates.entityEmpty.clone().get());
	      }
	    }
	  }]);
	
	  return Ui;
	}();
	
	exports.default = Ui;

/***/ },
/* 11 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	var _finder = __webpack_require__(5);
	
	var _finder2 = _interopRequireDefault(_finder);
	
	var _textnodexpath = __webpack_require__(9);
	
	var _textnodexpath2 = _interopRequireDefault(_textnodexpath);
	
	var _range = __webpack_require__(4);
	
	var _range2 = _interopRequireDefault(_range);
	
	var _util = __webpack_require__(2);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }
	
	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
	
	/**
	 * <p>Class responsible for locating text in a <code>TextContent</code>
	 * instance from an XPath representation and start and end offsets.</p>
	 * @class
	 *
	 * @param {TextContent} content - Reference to <code>TextContent</code>
	 * instance.
	 * @param {string} subject - Descriptor containing an XPath representation
	 * and start and end offsets. */
	var XpathFinder = function (_Finder) {
	  _inherits(XpathFinder, _Finder);
	
	  function XpathFinder(content, subject) {
	    _classCallCheck(this, XpathFinder);
	
	    var _this = _possibleConstructorReturn(this, (XpathFinder.__proto__ || Object.getPrototypeOf(XpathFinder)).call(this, content));
	    /* Construct base class. */
	
	
	    if (!(0, _util.is_obj)(subject) || subject.start.offset < 0 || subject.end.offset < 0) {
	      throw new Error("Invalid or no XPath object specified");
	    }
	
	    /* Compute text node start and end elements that the XPath representation
	     * refers to. */
	    var end = void 0;
	    var xpath = new _textnodexpath2.default(_this.content.root),
	        start = xpath.elementAt(subject.start.xpath);
	
	    /* If an element could not be obtained from the XPath representation, abort
	     * now (messages will have been output).*/
	    if (start === null) return _possibleConstructorReturn(_this);
	    end = xpath.elementAt(subject.end.xpath);
	
	    if (end === null) return _possibleConstructorReturn(_this);
	
	    /* Retrieve global character offset of the text node. */
	    start = content.find(start);end = content.find(end);
	    if (start < 0 || end < 0) {
	      console.error("Unable to derive global offsets: %d:%d", start, end);
	      return _possibleConstructorReturn(_this);
	    }
	
	    /* Retrieve offset markers. */
	    start = content.at(start).offset + subject.start.offset;
	    end = content.at(end).offset + subject.end.offset - 1;
	
	    /*     console.log("DEBUG start = ", start, "end = ", end, subject); */
	
	    if (start === end) {
	      throw new Error("Invalid XPath representation: start == end");
	    } else if (start > end) {
	      throw new Error("Invalid XPath representation: start > end");
	    }
	
	    /* Save global character offset and relative start and end offsets in
	     * descriptor. */
	    _this.results.push({ start: start, end: end });
	    return _this;
	  }
	
	  /**
	   * <p>Return next available match.</p>
	   *
	   * @returns {Range|false} Returns a <code>Range</code> if a match is
	   * available, or <code>false</code> if no more matches are available. */
	
	
	  _createClass(XpathFinder, [{
	    key: "next",
	    value: function next() {
	      if (this.current >= this.results.length) return false;
	
	      var subject = this.results[this.current];
	      ++this.current;
	
	      /* TODO: we don't necessarily need to invoke getAt_ for the end offset.  A
	       * check has to be made to ascertain if the end offset falls within the
	       * start node. */
	      return new _range2.default(this.content, this.getAt_(subject.start), this.getAt_(subject.end));
	    }
	  }]);
	
	  return XpathFinder;
	}(_finder2.default);
	
	exports.default = XpathFinder;

/***/ },
/* 12 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	var _jquery = __webpack_require__(1);
	
	var _jquery2 = _interopRequireDefault(_jquery);
	
	var _consts = __webpack_require__(3);
	
	var _util = __webpack_require__(2);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	/**
	 * <p>Class responsible for managing the state of the highlight cursor.</p>
	 * @class
	 * @param {Object} owner - Reference to the owning instance.
	 * */
	var Cursor = function () {
	  function Cursor(owner) {
	    _classCallCheck(this, Cursor);
	
	    this.owner = owner;
	    this.index = -1;
	    this.iterableQueries = null;
	    this.total = 0;
	    this.setIterableQueries(null);
	  }
	
	  /**
	   * <p>Clear the current cursor state and recalculate number of total
	   * iterable highlights.</p> */
	
	
	  _createClass(Cursor, [{
	    key: "clear",
	    value: function clear() {
	      this.clearActive_();
	      this.index = -1;
	      this.update();
	    }
	
	    /**
	     * <p>Set or clear the query sets that the cursor can move through.<p>
	     *
	     * <p>When one or more query sets are specified, cursor movement is
	     * restricted to the specified query sets.  When setting the cursor offset,
	     * the offset will then apply within the context of the active iterable
	     * query sets.<p>
	     *
	     * <p>The restriction can be lifted at any time by passing <code>null</code>
	     * to the method.</p>
	     *
	     * @param {(Array|string)} queries - An array (or string) containing the
	     * query set names. */
	
	  }, {
	    key: "setIterableQueries",
	    value: function setIterableQueries(queries) {
	      if (queries === null) {
	        this.iterableQueries = null;
	      } else {
	        this.iterableQueries = (0, _util.is_arr)(queries) ? queries.slice() : [queries];
	      }
	
	      this.clear();
	    }
	
	    /**
	     * <p>Update the total of iterable highlights.<p>
	     * <p>Does <strong>not</strong> update the UI state.  The caller is
	     * responsible for doing so.</p>. */
	
	  }, {
	    key: "update",
	    value: function update() {
	      var iterable = this.iterableQueries;
	      if (iterable === null) {
	        this.total = this.owner.stats.total;
	        return;
	      } else if (iterable.length === 0) {
	        this.total = 0;
	        return;
	      }
	
	      var markers = this.owner.highlights,
	          total = 0;
	      for (var i = markers.length - 1; i >= 0; --i) {
	        if (iterable.indexOf(markers[i].query.name) >= 0) ++total;
	      }
	
	      this.total = total;
	    }
	
	    /**
	     * <p>Set cursor to query referenced by absolute query index.</p>
	     *
	     * @param {integer} index - Virtual cursor index */
	
	  }, {
	    key: "set",
	    value: function set(index, dontRecurse) {
	      var owner = this.owner;
	      var markers = owner.highlights;
	
	      if (index < 0) {
	        throw new Error("Invalid cursor index specified: " + index);
	      } else if (owner.stats.total <= 0) {
	        return;
	      }
	
	      var count = index,
	          ndx = null;
	      var iterable = this.iterableQueries;
	
	      markers.some(function (m, i) {
	        var q = m.query;
	        if (!q.enabled) {
	          return false;
	        } else if (iterable !== null && iterable.indexOf(q.name) < 0) {
	          return false;
	        } else if (count === 0) {
	          ndx = i;
	          return true;
	        }
	
	        --count;
	        return false;
	      });
	
	      /* If index overflown, set to first highlight. */
	      if (ndx === null) {
	        if (!dontRecurse) this.set(0, true);
	        return;
	      }
	
	      /* Clear currently active highlight, if any, and set requested highlight
	       * active. */
	      this.clearActive_();
	      var c = markers[ndx];
	      var $el = (0, _jquery2.default)("." + _consts.Css.highlight + "-id-" + (c.query.id + c.index)).addClass(_consts.Css.enabled).eq(0);
	
	      /* Scroll viewport if element not visible. */
	      if (typeof owner.options.scrollTo !== "undefined") {
	        owner.options.scrollTo($el);
	      } else if (!(0, _util.inview)($el)) {
	        (0, _util.scrollIntoView)($el, owner.options.scrollNode);
	      }
	
	      this.index = index;
	    }
	
	    /* Private interface
	     * ----------------- */
	    /**
	     * <p>Clear the currently active cursor highlight.  The active cursor
	     * highlight is the element or elements at the current cursor position.</p>
	     * @access private
	     * */
	
	  }, {
	    key: "clearActive_",
	    value: function clearActive_() {
	      (0, _jquery2.default)("." + _consts.Css.highlight + "." + _consts.Css.enabled).removeClass(_consts.Css.enabled);
	    }
	  }]);
	
	  return Cursor;
	}();
	
	exports.default = Cursor;

/***/ },
/* 13 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _jquery = __webpack_require__(1);
	
	var _jquery2 = _interopRequireDefault(_jquery);
	
	var _consts = __webpack_require__(3);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	/**
	 * <p>Convenience class for removing highlighting.</p>
	 * @class
	 * */
	var RangeUnhighlighter = function RangeUnhighlighter() {
	  /**
	   * <p>Remove highlighting given by its id.</p>
	   *
	   * @param {number} id - Id of the highlight to remove. */
	  this.undo = function (id) {
	    (0, _jquery2.default)("." + _consts.Css.highlight + "-id-" + id).each(function () {
	      var $el = (0, _jquery2.default)(this);
	
	      $el.contents().insertBefore($el);
	      $el.remove();
	    });
	  };
	};
	
	exports.default = RangeUnhighlighter;

/***/ },
/* 14 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	var _jquery = __webpack_require__(1);
	
	var _jquery2 = _interopRequireDefault(_jquery);
	
	var _htmlhighlighter = __webpack_require__(6);
	
	var _htmlhighlighter2 = _interopRequireDefault(_htmlhighlighter);
	
	var _util = __webpack_require__(2);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	/**
	 * <p>Class responsible for building and keeping a convenient representation
	 * of the text present in an HTML DOM sub-tree.</p>
	 * @class
	 * @param {DOMElement|jQuery} root - Reference to a DOM element or jQuery
	 * instance.  If a jQuery instance is given, its first element is used.
	 * */
	var TextContent = function () {
	  function TextContent(root) {
	    _classCallCheck(this, TextContent);
	
	    this.root = (0, _util.is_$)(root) ? root.get(0) : root;
	    this.text = this.markers = null;
	    this.refresh();
	  }
	
	  /**
	   * <p>Refreshes the internal representation of the text.</p>
	   *
	   * <p>The internal representation of the text present in the DOM sub-tree of
	   * the <code>root</code> consists of an array of global offsets for every
	   * text node in the document, and a reference to the corresponding text node,
	   * stored in <i>marker</i> descriptors. In addition, a regular string
	   * (<code>text</code>) holds the text contents of the document to enable
	   * text-based searches.</p>
	   *
	   * <p>A marker descriptor is of the form:</p>
	   * <pre>{
	   *   node:   DOMElement  // reference to DOMElement of text node
	   *   offset: integer     // global offset
	   * }</pre>
	   *
	   * <p>Should only be invoked when the HTML structure mutates, e.g. a new
	   * document is loaded.</p>
	   * */
	
	
	  _createClass(TextContent, [{
	    key: "refresh",
	    value: function refresh() {
	      this.text = "";
	      var markers = this.markers = [];
	      var offset = this.visit_(this.root, 0);
	
	      /* FIXME: bypass when not in debug mode. */
	      /* Sanity check. */
	      if (this.markers.length !== 0) {
	        var marker = markers[markers.length - 1];
	        if (offset - marker.node.nodeValue.length != marker.offset) {
	          throw new Error("Invalid state detected: offset mismatch");
	        }
	      }
	    }
	
	    /**
	     * <p>Truncate a text node given by <code>marker</code> by turning it into 2
	     * or 3 text nodes, with one of them used for highlighting purposes.</p>
	     *
	     * <p>If <code>start == 0</code> and <code>end == text.length - 1</code>, no
	     * truncation takes place <strong>but</strong> the old text node is replaced
	     * by a new one.  This method therefore assumes that the caller has checked
	     * to ensure text truncation is required.</p>
	     *
	     * <p>Truncation takes place in the following manner:</p>
	     *
	     * <ul><li>if <code>start > 0</code>: truncate <code>[ 0 .. start - 1
	     * ]</code></li>
	     *
	     * <li>create new text node at <code>[ start .. end ]</code></li>
	     *
	     * <li>if <code>end != text.length - 1</code>: truncate <code>[ end
	     * .. text.length - 1 ]</code></li></ul>
	     *
	     * @param {Object} marker - Reference to descriptor of text node to
	     * truncate.
	     * @param {number} start - Offset where to start truncation.
	     * @param {number} end - Offset where truncation ends. */
	
	  }, {
	    key: "truncate",
	    value: function truncate(marker, start, end) {
	      var text = marker.node.nodeValue;
	      var index = this.indexOf(marker.offset);
	      var old = marker.node; /* The old text node. */
	
	      /* Sanity checks */
	      if (start < 0 || end < 0 || end >= text.length) {
	        throw new Error("Invalid truncation parameters");
	      }
	
	      /* Chars 0..start - 1 */
	      if (start > 0) {
	        /* Since we're creating a new text node out of the old text node, we need
	         * to add a new entry to the markers array. */
	        this.markers.splice(index, 0, {
	          offset: marker.offset,
	          node: (0, _jquery2.default)(document.createTextNode(text.substr(0, start))).insertBefore(marker.node).get(0)
	        });
	
	        ++index;
	      }
	
	      /* Chars start..end
	       * ----------------
	       * We don't need to add a new entry to the markers array since we're not
	       * technically creating a new text node, just replacing it with one with
	       * the required [start..end] substring.  We do need to update the node's
	       * offset though. */
	      marker.offset += start;
	      marker.node = (0, _jquery2.default)(document.createTextNode(text.substr(start, end - start + 1))).insertBefore(marker.node).get(0);
	
	      /* Chars end + 1..length */
	      if (end !== text.length - 1) {
	        if (index >= this.markers.length) {
	          throw new Error("Detected invalid index");
	        }
	
	        /* We're again creating a new text node out of the old text node and thus
	         * need to add a new entry to the markers array. */
	        this.markers.splice(index + 1, 0, {
	          offset: marker.offset + end - start + 1,
	          node: (0, _jquery2.default)(document.createTextNode(text.substr(end + 1))).insertAfter(marker.node).get(0)
	        });
	      }
	
	      /* From global state since we don't have access to the `options`
	       * descriptor. */
	      if (_htmlhighlighter2.default.debug) this.assert_();
	
	      /* Remove old node. */
	      old.parentNode.removeChild(old);
	
	      return index;
	    }
	
	    /**
	     * <p>Return the index of the marker descriptor of a given text offset.</p>
	     *
	     * <p>Throws an exception if the offset is invalid.</p>
	     *
	     * <p>Note: employs the binary search algorithm.</p>
	     *
	     * @param {number} offset - The offset to look up.
	     * @returns {number} The marker index that contains <code>offset</code>. */
	
	  }, {
	    key: "indexOf",
	    value: function indexOf(offset) {
	      var markers = this.markers;
	      var min = 0,
	          max = markers.length - 1;
	
	      while (min < max) {
	        var mid = Math.floor((min + max) / 2);
	
	        if (markers[mid].offset < offset) min = mid + 1;else max = mid;
	      }
	
	      if (markers[min].offset <= offset) {
	        return min;
	      } else if (min === 0) {
	        throw new Error("Invalid offset of text content state");
	      }
	
	      return min - 1;
	    }
	
	    /**
	     * <p>Find the index of the marker descriptor of a given text node
	     * element.</p>
	     *
	     * @param {DOMElement} element - Reference to the text node to look up.
	     * @param {number} [start=0] - Start marker index if known for a fact that
	     * the text node is to be found <strong>after</strong> a certain offset.
	     *
	     * @returns {number} The marker index of <code>element</code> or
	     * <code>-1</code> if not found. */
	
	  }, {
	    key: "find",
	    value: function find(element, start) {
	      if (element.nodeType !== 3) return -1;
	
	      for (var i = start === undefined ? 0 : start, l = this.markers.length; i < l; ++i) {
	        if (this.markers[i].node === element) return i;
	      }
	
	      return -1;
	    }
	
	    /**
	     * <p>Return the offset marker descriptor at a given index.</p>
	     *
	     * <p>Throws an exception if the given <code>index</code> is out of
	     * bounds.</p>
	     *
	     * @param {number} index - Marker index.
	     * @returns {Object} The offset marker descriptor. */
	
	  }, {
	    key: "at",
	    value: function at(index) {
	      if (index < 0 || index >= this.markers.length) {
	        throw new Error("Invalid marker index");
	      }
	
	      return this.markers[index];
	    }
	
	    /**
	     * <p>Recursively build a representation of the text contained in the HTML
	     * DOM sub-tree in the form of a string containing the text and global
	     * offsets of each text node.</p>
	     * @access private
	     *
	     * @param {DOMElement} node - The node to visit. */
	
	  }, {
	    key: "visit_",
	    value: function visit_(node, offset) {
	      /* Only interested in text nodes. */
	      if (node.nodeType === 3) {
	        var content = node.nodeValue;
	        var length = content.length;
	
	        /* Save reference to text node and store global offset in the markers
	         * array, in addition to . */
	        this.markers.push({ node: node, offset: offset });
	        this.text += content;
	        return offset + length;
	      }
	
	      /* If current node is not of type text, process its children nodes, if
	       * any. */
	      var ch = node.childNodes;
	      if (ch.length > 0) {
	        for (var i = 0, l = ch.length; i < l; ++i) {
	          offset = this.visit_(ch[i], offset);
	        }
	      }
	
	      return offset;
	    }
	
	    /**
	     * <p>Debug method for asserting that the current textual representation if
	     * valid, in particular that the offset markers are all contiguous.</p> */
	
	  }, {
	    key: "assert_",
	    value: function assert_() {
	      var offset = 0;
	
	      /* Ensure offsets are contiguous. */
	      for (var i = 0, l = this.markers.length; i < l; ++i) {
	        var marker = this.markers[i];
	
	        if (marker.offset !== offset) {
	          console.error("Invalid offset: %d@ %d:%d ->", i, marker.offset, offset, marker);
	          throw new Error("Invalid offset");
	        }
	
	        offset += marker.node.nodeValue.length;
	      }
	    }
	  }]);
	
	  return TextContent;
	}();
	
	exports.default = TextContent;

/***/ },
/* 15 */
/***/ function(module, exports) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	/**
	 * <p>Convenient class for visiting all text nodes that are siblings and
	 * descendants of a given root node.</p>
	 * @class
	 * @param {DOMElement} node - The node where to start visiting the DOM.
	 * @param {DOMElement} [root=null] - The root node where to stop visiting the
	 * DOM.
	 * */
	var TextNodeVisitor = function TextNodeVisitor(node, root) {
	  /* Attributes */
	  var current = node;
	
	  /* Getters */
	  Object.defineProperty(this, "current", { get: function get() {
	      return current;
	    } });
	
	  /**
	   * Get the next text node.
	   *
	   * @returns {DOMElement} The next text node or <code>null</code> if none
	   * found. */
	  this.next = function () {
	    if (current.nodeType !== 3) {
	      throw new Error("Invalid node type: not text");
	    }
	
	    return current = nextText_(nextNode_(current));
	  };
	
	  /* Private interface
	   * ----------------- */
	  /**
	   * Get the next node, text or otherwise, that is either a sibling or
	   * parent to a given node.
	   *
	   * @param {DOMElement} node current node.
	   * @returns {DOMElement} next node or <code>null</code> if none
	   * available or the root node was reached. */
	  function nextNode_(node) {
	    /* Abort if invalid or root node; otherwise attempt to advance to sibling
	     * node. */
	    if (node === null) {
	      throw new Error("Invalid state: outside of root sub-tree");
	    } else if (node === root) {
	      return null;
	    } else if (node.nextSibling !== null) {
	      return node.nextSibling;
	    }
	
	    /* Move up to sibling of parent node. */
	    return nextNode_(node.parentNode);
	  }
	
	  /**
	   * Get the next available text node that is either a descendant, sibling or
	   * otherwise, of a given node.
	   *
	   * @param {DOMElement} node current node.
	   * @returns {DOMElement} next node or <code>null</code> if none
	   * available or the root node was reached. */
	  function nextText_(node) {
	    if (node === root || node.nodeType === 3) return node;
	
	    var ch = node.childNodes;
	    if (ch.length > 0) return nextText_(ch[0]);
	
	    return nextText_(nextNode_(node));
	  }
	};
	
	exports.default = TextNodeVisitor;

/***/ },
/* 16 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _util = __webpack_require__(2);
	
	/**
	 * @class
	 * */
	var NodeFinder = function NodeFinder(tag, prefix, root) {
	  this.tag_ = tag;
	  this.prefix_ = ["[", tag, '="', prefix && prefix.length > 0 ? prefix + "-" : ""].join("");
	  this.root_ = root;
	}; /* FIXME: refactor and remove. */
	
	
	NodeFinder.prototype = {
	  tag_: null,
	  prefix_: null,
	  root_: null,
	
	  get root() {
	    return this.root_;
	  },
	
	  find: function find(scope, parent /* = prefix */) {
	    var p = void 0;
	
	    if ((0, _util.is_$)(parent)) p = parent;else if ((0, _util.is_str)(parent)) p = this.find(parent);else p = this.root_;
	
	    return p.find([this.prefix_, scope, '"]'].join(""));
	  },
	
	  withroot: function withroot(newRoot, callback) {
	    if (!(0, _util.is_fn)(callback)) {
	      throw new Error("Invalid or no callback function specified");
	    }
	
	    var t = this.root_;
	    var v = void 0;
	    this.root_ = newRoot;
	    v = callback.call(this);
	    this.root_ = t;
	    return v;
	  }
	};
	
	exports.default = NodeFinder;

/***/ },
/* 17 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _jquery = __webpack_require__(1);
	
	var _jquery2 = _interopRequireDefault(_jquery);
	
	var _templateinstance = __webpack_require__(19);
	
	var _templateinstance2 = _interopRequireDefault(_templateinstance);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	/**
	 * @class
	 * */
	/* FIXME: refactor and remove. */
	var Template = function Template(html, tag) {
	  this.html = html;
	  this.tag = tag || null;
	
	  Object.defineProperty(this, "html", { value: html });
	};
	
	Template.prototype.clone = function () {
	  return new _templateinstance2.default((0, _jquery2.default)(this.html), this.tag);
	};
	
	exports.default = Template;

/***/ },
/* 18 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _template = __webpack_require__(17);
	
	var _template2 = _interopRequireDefault(_template);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	/**
	 * @class
	 * */
	var TemplateFinder = function TemplateFinder(type, tag) {
	  this.scripts = Array.prototype.slice.call(document.getElementsByTagName("script"), 0).filter(function (i) {
	    return i.type === type;
	  });
	
	  this.tag = tag || "data-scope";
	}; /* FIXME: refactor and remove. */
	
	
	TemplateFinder.prototype.find = function (id) {
	  for (var i = 0, l = this.scripts.length; i < l; ++i) {
	    if (this.scripts[i].id === id) return new _template2.default(this.scripts[i].innerHTML, this.tag);
	  }
	
	  return null;
	};
	
	exports.default = TemplateFinder;

/***/ },
/* 19 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _jquery = __webpack_require__(1);
	
	var _jquery2 = _interopRequireDefault(_jquery);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	/**
	 * @class
	 * */
	var TemplateInstance = function TemplateInstance(node, tag) {
	  this.node = node;
	  this.tag = tag || null;
	}; /* FIXME: refactor and remove. */
	
	
	TemplateInstance.prototype.get = function () {
	  return this.node;
	};
	
	TemplateInstance.prototype.find = function (scope) {
	  if (this.prefix === null) return (0, _jquery2.default)();
	  return this.node.find("[" + this.tag + "=" + scope + "]");
	};
	
	exports.default = TemplateInstance;

/***/ }
/******/ ])
});
;
//# sourceMappingURL=html_highlighter.js.map